"""initial migration

Revision ID: 720f26d6c530
Revises: 
Create Date: 2021-12-26 20:47:11.761688

"""
import csv
import datetime

import sqlalchemy as sa
from alembic import op


# revision identifiers, used by Alembic.
revision = "720f26d6c530"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    techs = op.create_table(
        "Technologies",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("name", sa.String(length=25), nullable=False),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "candidate",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("name", sa.String(length=255), nullable=False),
        sa.Column("surname", sa.String(length=255), nullable=False),
        sa.Column("cellphone", sa.String(length=20), nullable=False),
        sa.Column("linkedin", sa.String(length=255), nullable=True),
        sa.Column("other_webpage", sa.String(length=255), nullable=True),
        sa.Column("bio", sa.String(length=255), nullable=True),
        sa.Column("github", sa.String(length=255), nullable=True),
        sa.Column("gitlab", sa.String(length=255), nullable=True),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("bio"),
    )
    op.create_table(
        "company",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("name", sa.String(length=255), nullable=False),
        sa.Column("description", sa.String(length=255), nullable=False),
        sa.PrimaryKeyConstraint("id"),
    )
    countries = op.create_table(
        "countries_cities",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("country", sa.String(length=255), nullable=False),
        sa.Column("province", sa.String(length=255), nullable=False),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "responsable",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.PrimaryKeyConstraint("id"),
    )
    users = op.create_table(
        "users",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("user_id", sa.String(length=255), nullable=False),
        sa.Column("email", sa.String(length=255), nullable=False),
        sa.Column("password_hash", sa.String(length=100), nullable=True),
        sa.Column("register_on", sa.DateTime(), nullable=False),
        sa.Column("last_pass_change", sa.DateTime(), nullable=True),
        sa.Column("last_login", sa.DateTime(), nullable=True),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("email"),
    )
    op.create_table(
        "job",
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("title", sa.String(length=255), nullable=False),
        sa.Column("description", sa.String(length=255), nullable=False),
        sa.Column("start", sa.DateTime(), nullable=False),
        sa.Column("closing", sa.DateTime(), nullable=False),
        sa.Column("status", sa.String(length=25), nullable=False),
        sa.Column("company_id", sa.Integer(), nullable=True),
        sa.PrimaryKeyConstraint("id"),
    )
    # ### end Alembic commands ###

    admin_user = [
        {
            "user_id": "admin",
            "email": "admin@admin.com",
            "password_hash": "$2b$12$L1Glnc6IiLezG2J4.hdNJ.DONz2rIWX0V.P98wLUQXH120pci1YP2",
            "register_on": datetime.datetime.today(),
        }
    ]
    op.bulk_insert(users, admin_user)

    with open("worldcities.csv", "r") as f:
        reader = csv.DictReader(f)
        country_list = [row for row in reader]

    op.bulk_insert(countries, country_list)

    with open("lang.csv", "r") as f:
        reader = csv.DictReader(f)
        langs = [row for row in reader]

    op.bulk_insert(techs, langs)


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("job")
    op.drop_table("users")
    op.drop_table("responsable")
    op.drop_table("countries_cities")
    op.drop_table("company")
    op.drop_table("candidate")
    op.drop_table("Technologies")
    # ### end Alembic commands ###
